SystemOrganization addCategory: #Perspectives!
SystemOrganization addCategory: #'Perspectives-Tests'!
SystemOrganization addCategory: #'Perspectives-Visualization'!

Object subclass: #AbstractMethodLookup
	instanceVariableNames: 'lookupClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!AbstractMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 01:02'!
inClassHierarchyLookupSelector: aSelector
	 | method | 
	method := lookupClass lookupSelector: aSelector.
	method isCompiledMethod not ifTrue: [ method := method method ].
	^ method! !

!AbstractMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:32'!
lookupClass
	^ lookupClass! !

!AbstractMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:32'!
lookupClass: aClass
	lookupClass := aClass! !

!AbstractMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:28'!
lookupSelector: aSelector
	self subclassResponsibility! !

!AbstractMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:33'!
on: receiver perform: selector withArguments: arguments
	| method |
	method := self lookupSelector: selector.
	method ifNil: [ ^ receiver doesNotUnderstand: 
		((Message selector: selector arguments: arguments)
			lookupClass: lookupClass;
			yourself) ].
	^ receiver withArgs: arguments executeMethod: method! !

!AbstractMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:09'!
sendMessage: aMessage to: receiver
	^ self on: receiver perform: aMessage selector withArguments: aMessage arguments! !

AbstractMethodLookup subclass: #DefaultMethodLookup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!DefaultMethodLookup class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:33'!
for: aClass
	^ self new
		lookupClass: aClass;
		yourself! !

!DefaultMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 01:03'!
lookupSelector: aSelector
	^ self inClassHierarchyLookupSelector: aSelector! !

AbstractMethodLookup subclass: #PerspectiveMethodLookup
	instanceVariableNames: 'perspective'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PerspectiveMethodLookup class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:35'!
for: aClass from: aPerspective
	^ self new
		lookupClass: aClass;
		perspective: aPerspective;
		yourself! !

!PerspectiveMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:29'!
inPerspectiveHierarchyLookupSelector: aSelector
	| p |
	p := perspective.
	[p isNil or: [p methodDict includesKey: aSelector]] whileFalse: [ p := p parentLayer ].
	^ p ifNotNil: [ p compiledMethodAt: aSelector ]! !

!PerspectiveMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:19'!
isHidden: aMethod
	^ aMethod
		ifNil: [ false ]
		ifNotNil: [ :method |
			method pragmas
				anySatisfy: [ :pragma | pragma arguments
					anySatisfy: [ :arg | arg = #hide ] ] ]! !

!PerspectiveMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:25'!
lookupSelector: aSelector
	| method |
	method := self inPerspectiveHierarchyLookupSelector: aSelector.
	(self isHidden: method) ifTrue: [ ^ nil ].
	method ifNil: [ method := self inClassHierarchyLookupSelector: aSelector ].
	^ method! !

!PerspectiveMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:33'!
perspective
	^ perspective! !

!PerspectiveMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:33'!
perspective: aPerspective
	perspective := aPerspective! !

Object subclass: #PerspectiveLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

PerspectiveLayer class
	instanceVariableNames: 'parentLayer'!

PerspectiveLayer class
	instanceVariableNames: 'parentLayer'!

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/7/2011 12:09'!
hasParentLayer
	^ parentLayer notNil! !

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
initialParentLayer
	"subclasses should override this and return the initial parent layer to be used upon class creation"
	^ nil! !

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/7/2011 11:56'!
new
	self shouldNotImplement! !

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
parentLayer
	^ parentLayer ifNil: [ self initialParentLayer ]! !

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:13'!
parentLayer: aLayer
	(aLayer inheritsFrom: PerspectiveLayer)
		ifTrue: [ parentLayer := aLayer ]
		ifFalse: [ self error: 'parentLayer has to be a subclass of PerspectiveLayer' ]! !

PerspectiveLayer subclass: #TestChildLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
initialParentLayer
	^ TestLayer! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:45'!
isTestChildLayer
	^ true! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:13'!
method1
	<pragma: #hide>! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:29'!
newMethod
	^ 2! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:25'!
returnValue
	^ 15! !

PerspectiveLayer subclass: #TestLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:44'!
isTestLayer
	^ true! !

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:19'!
returnValue
	^ 23! !

Object subclass: #PerspectiveMethodWrapper
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PerspectiveMethodWrapper class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:04'!
for: aCompiledMethod
	^ self new
		method: aCompiledMethod;
		yourself! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 15:12'!
doesNotUnderstand: aMessage
	^ aMessage sendTo: method! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 15:07'!
method
	^ method! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 15:07'!
method: aCompiledMethod
	method := aCompiledMethod! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:10'!
run: selector with: arguments in: receiver
	^ receiver methodLookup
		on: receiver
		perform: selector
		withArguments: arguments! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:34'!
selector
	^ method selector! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:10'!
selector: aSelector
	"ignore"
! !

Object subclass: #PerspectiveObject
	instanceVariableNames: 'methodLookup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PerspectiveObject class methodsFor: 'as yet unclassified' stamp: 'RL 12/5/2011 02:31'!
addSelector: selector withMethod: compiledMethod notifying: requestor
	^ super
		addSelector: selector
		withMethod: (self = PerspectiveObject
			ifTrue: [ compiledMethod ]
			ifFalse: [ compiledMethod ])
		notifying: requestor! !

!PerspectiveObject class methodsFor: 'as yet unclassified' stamp: 'RL 12/5/2011 02:31'!
basicAddSelector: selector withMethod: compiledMethod
	^ super
		basicAddSelector: selector
		withMethod: (self = PerspectiveObject
			ifTrue: [ compiledMethod ]
			ifFalse: [ self wrapMethod: compiledMethod ])! !

!PerspectiveObject class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:04'!
wrapMethod: aCompiledMethod
	^ PerspectiveMethodWrapper for: aCompiledMethod! !

!PerspectiveObject methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 21:22'!
= anObject
	^ anObject class = Piece
		ifTrue: [ anObject = self ]
		ifFalse: [ self == anObject ]! !

!PerspectiveObject methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:56'!
@ aPerspectiveLayer
	^ Piece for: self in: aPerspectiveLayer! !

!PerspectiveObject methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:47'!
methodLookup
	^ methodLookup ifNil: [ methodLookup := DefaultMethodLookup for: self class ]! !

!PerspectiveObject methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:48'!
methodLookup: aMethodLookup
	methodLookup := aMethodLookup! !

PerspectiveObject subclass: #PerspectiveObject1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!PerspectiveObject1 methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 23:55'!
callReturnValue
	^ self returnValue! !

!PerspectiveObject1 methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:13'!
method1
	"not hidden"! !

!PerspectiveObject1 methodsFor: 'as yet unclassified' stamp: 'RL 12/5/2011 02:31'!
returnValue
	^ 42! !

TestCase subclass: #TestPerspectives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testDirectPerspectiveCall
	| object |
	object := PerspectiveObject1 new.
	self assert: [ object returnValue = 42 ].
	self assert: [ (object @ nil) returnValue = 42 ].
	self assert: [ (object @ TestLayer) returnValue = 23 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testDoesNotUnderstand
	| object |
	object := PerspectiveObject1 new.
	self should: [ object foo ] raise: MessageNotUnderstood.
	self should: [ (object @ nil) foo ] raise: MessageNotUnderstood.
	self should: [ (object @ TestLayer) foo ] raise: MessageNotUnderstood.! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:42'!
testHiddenMethod
	| object |
	object := PerspectiveObject1 new.
	object method1.
	(object @ TestLayer) method1.
	self should: [ (object @ TestChildLayer) method1 ] raise: MessageNotUnderstood.! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testIdentityInvariant
	| object |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) = (object @ TestChildLayer) ].
	self assert: [ (object @ TestLayer) = object ].
	self assert: [ object = (object @ TestLayer) ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testIndirectPerspectiveCall
	| object |
	object := PerspectiveObject1 new.
	self assert: [ object callReturnValue = 42 ].
	self assert: [ (object @ TestLayer) callReturnValue = 23 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testLayerSwitching
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestChildLayer @ TestLayer) returnValue = 23 ].
	self assert: [ (object @ TestLayer @ TestChildLayer) returnValue = 15 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:46'!
testParentLayer
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) returnValue = 23 ].
	self assert: [ (object @ TestChildLayer) returnValue = 15 ].
	
	self assert: [ (object @ TestLayer) isTestLayer ].
	self assert: [ (object @ TestChildLayer) isTestLayer ].
	
	self assert: [ (object @ TestChildLayer) isTestChildLayer ].
	self should: [ (object @ TestLayer) isTestChildLayer ] raise: MessageNotUnderstood.
	! !

SystemWindow subclass: #PVisualizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PVisualizer class methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 00:40'!
open
	"^ self new openInWorldExtent: 800@600"
	^ self new openInWorld! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 00:00'!
a
	^ #('1' '2' '3' '4' '5' '6' '7' '8' '9' '10') asOrderedCollection! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/13/2011 19:24'!
b
	^ 1! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/13/2011 20:46'!
c: s
	! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 12:01'!
createChildren
	| htop hbottom wleft |
	htop := 0.2.
	hbottom := 0.2.
	wleft := 0.3.
	self
		addMorph: self createUpperPane frame: (0@0 corner: 1@htop);
		addMorph: self createList frame: (0@htop corner: wleft@(1-hbottom));
		addMorph: self createPane frame: (wleft@htop corner: 1@(1-hbottom));
		addMorph: self createLowerPane frame: (0@(1-hbottom) corner: 1@1)! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 11:54'!
createList
	^ (PluggableListMorph
		on: self
		list: #a
		selected: #b
		changeSelected: #c:)
			color: Color white;
			yourself
		! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:07'!
createLowerPane
	^ PluggableTextMorphPlus
		on: self
		text: #name
		accept: #c:! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 11:54'!
createPane
	^ PluggablePanelMorph new
		color: Color white;
		yourself! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:14'!
createUpperPane
	| text |
	text := PluggableTextMorphPlus
		on: self
		text: #name
		accept: #c:.
	text styler: (SHTextStylerST80 new view: text; yourself).
	text textMorph editor model: self.
	^ text! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:14'!
doItContext
	^ nil! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:15'!
doItReceiver
	^ self ! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 02:31'!
initialize
	super initialize.
	self
		setLabel: 'PVisualizer';
		setWindowColor: self defaultColor;
		createChildren! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:13'!
selectedClass
	^ self class! !

ProtoObject subclass: #Piece
	instanceVariableNames: 'object methodLookup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!Piece class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:49'!
for: anObject in: aPerspective
	^ self new
		initializeOnObject: anObject andPerspective: aPerspective! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:10'!
doesNotUnderstand: aMessage
	| result oldLookup |
	oldLookup := object methodLookup.
	object methodLookup: methodLookup.
	result := methodLookup
		sendMessage: aMessage
		to: object.
	object methodLookup: oldLookup.
	^ result! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:51'!
initializeOnObject: anObject andPerspective: aPerspective
	object := anObject.
	methodLookup := PerspectiveMethodLookup for: anObject class from: aPerspective.
	^ self! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:32'!
inspect
	ToolSet inspect: self! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:34'!
printOn: aStream
	aStream
		nextPutAll: 'a Piece'.! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:17'!
printString
	^ 'a Piece'! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:17'!
printStringLimitedTo: limit
	"Answer a String whose characters are a description of the receiver.
	If you want to print without a character limit, use fullPrintString."
	| limitedString |
	limitedString := String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...etc...'! !
